﻿'
' Copyright (c) 2009-2013, MindFusion LLC - Bulgaria.
'

Public Class CalendarEvent
    Public Sub New(ByVal id As Guid, ByVal name As String, ByVal details As String, ByVal startTime As DateTime, ByVal duration As TimeSpan)
        Me.Id = id
        Me.Name = name
        Me.Details = details
        Me.StartTime = startTime
        Me.Duration = duration
    End Sub
    Public Sub New()
        Me.New(Guid.NewGuid(), "new event", "", DateTime.Now, TimeSpan.FromHours(2))
    End Sub

    Public Sub CopyFrom(ByVal another As CalendarEvent)
        If Name <> another.Name Then
            Name = another.Name
        End If
        If Details <> another.Details Then
            Details = another.Details
        End If
        If StartTime <> another.StartTime Then
            StartTime = another.StartTime
        End If
        If Duration <> another.Duration Then
            Duration = another.Duration
        End If
    End Sub

    Public Property Id() As Guid
        Get
            Return m_id
        End Get
        Set(ByVal value As Guid)
            m_id = value
        End Set
    End Property

    Public Property Name() As String
        Get
            Return m_name
        End Get
        Set(ByVal value As String)
            m_name = value
        End Set
    End Property

    Public Property Details() As String
        Get
            Return m_details
        End Get
        Set(ByVal value As String)
            m_details = value
        End Set
    End Property

    Public Property StartTime() As DateTime
        Get
            Return m_startTime
        End Get
        Set(ByVal value As DateTime)
            m_startTime = value
        End Set
    End Property

    Public Property Duration() As TimeSpan
        Get
            Return m_duration
        End Get
        Set(ByVal value As TimeSpan)
            m_duration = value
        End Set
    End Property

    Private m_id As Guid
    Private m_name As String
    Private m_details As String
    Private m_startTime As DateTime
    Private m_duration As TimeSpan
End Class
