﻿'
' Copyright (c) 2009-2013, MindFusion LLC - Bulgaria.
'

Imports MindFusion.Scheduling

Public Class EventToAppointmentConverter

    Public Shared Function CreateCalendarEvent(ByVal appointment As Appointment) As CalendarEvent
        If appointment Is Nothing Then
            Throw New ArgumentNullException("appointment", "appointment cannot be null")
        End If
        Return New CalendarEvent(New Guid(appointment.Tag.ToString()), appointment.HeaderText, appointment.Details, appointment.StartTime, appointment.EndTime - appointment.StartTime)
    End Function

    Public Shared Function CreateAppointment(ByVal calendarEvent As CalendarEvent) As Appointment
        If calendarEvent Is Nothing Then
            Throw New ArgumentNullException("calendarEvent", "calendarEvent cannot be null")
        End If
        Return New Appointment() With {.HeaderText = calendarEvent.Name, .Details = calendarEvent.Details, .StartTime = calendarEvent.StartTime, .EndTime = calendarEvent.StartTime + calendarEvent.Duration, .Tag = calendarEvent.Id}
    End Function

    Public Shared Function ConvertToXElement(ByVal calendarEvent As CalendarEvent) As XElement
        Dim xml = New XElement("CalendarEvent", New XElement("Id", calendarEvent.Id), New XElement("Name", calendarEvent.Name), New XElement("Details", calendarEvent.Details), New XElement("StartTime", calendarEvent.StartTime), New XElement("Duration", calendarEvent.Duration.ToString()))
        Return xml
    End Function

    Public Shared Function ConvertFromXElement(ByVal element As XElement) As CalendarEvent
        Dim id As New Guid(element.Element("Id").Value)
        Dim name As String = element.Element("Name").Value
        Dim details As String = element.Element("Details").Value
        Dim startTime As DateTime = DateTime.Parse(element.Element("StartTime").Value)
        Dim duration As TimeSpan = TimeSpan.Parse(element.Element("Duration").Value)
        Return New CalendarEvent(id, name, details, startTime, duration)
    End Function

End Class
